scala.tools.nsc.Global

# analysis

#### object analysis extends TypeFlowAnalysis

ICode analysis for optimization

Source
  Global.scala

Linear Supertypes
TypeFlowAnalysis, AnyRef, Any
Content Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. analysis
2. TypeFlowAnalysis
3. AnyRef
4. Any

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Type Members

1. #### case class CallsiteInfo(bb: Global.icodes.BasicBlock, receiver: Global.Symbol, stackLength: Int, concreteMethod: Global.Symbol) extends Product with Serializable

   Definition Classes
     TypeFlowAnalysis

2. #### class MTFAGrowable extends MethodTFA

   A full type-flow analysis on a method computes in- and out-flows for each basic block (that's what MethodTFA does).

   A full type-flow analysis on a method computes in- and out-flows for each basic block (that's what MethodTFA does).

   For the purposes of Inliner, doing so guarantees that an abstract typestack-slot is available by the time an inlining candidate (a CALL_METHOD instruction) is visited. This subclass (MTFAGrowable) of MethodTFA also aims at performing such analysis on CALL_METHOD instructions, with some differences:

   (a) early screening is performed while the type-flow is being computed (in an override of `blockTransfer`) by testing a subset of the conditions that Inliner checks later. The reasoning here is: if the early check fails at some iteration, there's no chance a follow-up iteration (with a yet more lub-ed typestack-slot) will succeed. Failure is sufficient to remove that particular CALL_METHOD from the typeflow's `remainingCALLs`. A forward note: in case inlining occurs at some basic block B, all blocks reachable from B get their CALL_METHOD instructions considered again as candidates (because of the more precise types that -- perhaps -- can be computed).

   (b) in case the early check does not fail, no conclusive decision can be made, thus the CALL_METHOD stays `isOnwatchlist`.

   In other words, `remainingCALLs` tracks those callsites that still remain as candidates for inlining, so that Inliner can focus on those. `remainingCALLs` also caches info about the typestack just before the callsite, so as to spare computing them again at inlining time.

   Besides caching, a further optimization involves skipping those basic blocks whose in-flow and out-flow isn't needed anyway (as explained next). A basic block lacking a callsite in `remainingCALLs`, when visisted by the standard algorithm, won't cause any inlining. But as we know from the way type-flows are computed, computing the in- and out-flow for a basic block relies in general on those of other basic blocks. In detail, we want to focus on that sub-graph of the CFG such that control flow may reach a remaining candidate callsite. Those basic blocks not in that subgraph can be skipped altogether. That's why:

   - `forwardAnalysis()` in `MTFAGrowable` now checks for inclusion of a basic block in `relevantBBs`
   - same check is performed before adding a block to the worklist, and as part of choosing successors. The bookkeeping supporting on-the-fly pruning of irrelevant blocks requires overridding most methods of the dataflow-analysis.

   The rest of the story takes place in Inliner, which does not visit all of the method's basic blocks but only on those represented in `remainingCALLs`.

   Definition Classes
     TypeFlowAnalysis

3. #### class MethodTFA extends DataFlowAnalysis[typeFlowLattice.type]

   Definition Classes
     TypeFlowAnalysis

4. #### class Timer extends AnyRef

   Definition Classes
     TypeFlowAnalysis

5. #### class VarBinding extends HashMap[Global.icodes.Local, Global.icodes.TypeKind]

   A map which returns the bottom type for unfound elements

   A map which returns the bottom type for unfound elements

   Definition Classes
     TypeFlowAnalysis

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

4. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

5. #### def clone(): AnyRef

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )

6. #### final def eq(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

7. #### def equals(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

8. #### def finalize(): Unit

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( classOf[java.lang.Throwable] )

9. #### final def getClass(): Class[_]

   Definition Classes
     AnyRef → Any

10. #### val global: Global.this.type

    Definition Classes
      analysis → TypeFlowAnalysis

11. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

12. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

13. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

14. #### final def notify(): Unit

    Definition Classes
      AnyRef

15. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

16. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

17. #### val timer: Timer

    Definition Classes
      TypeFlowAnalysis

18. #### def toString(): String

    Definition Classes
      AnyRef → Any

19. #### object typeFlowLattice extends SemiLattice

    The type flow lattice contains a binding from local variable names to types and a type stack.

    The type flow lattice contains a binding from local variable names to types and a type stack.

    Definition Classes
      TypeFlowAnalysis

20. #### object typeLattice extends SemiLattice

    The lattice of ICode types.

    The lattice of ICode types.

    Definition Classes
      TypeFlowAnalysis

21. #### object typeStackLattice extends SemiLattice

    The lattice of type stacks.

    The lattice of type stacks. It is a straight forward extension of the type lattice (lub is pairwise lub of the list elements).

    Definition Classes
      TypeFlowAnalysis

22. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

23. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

24. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

### Inherited from TypeFlowAnalysis

### Inherited from AnyRef

### Inherited from Any

### Ungrouped